import es
import cfglib
import playerlib
import spe


info = es.AddonInfo()
info.name = 'Dropped Health'
info.version = 1.2
info.basename = 'dropped_health'
info.url = 'http://addons.eventscripts.com/addons/view/dropped_health'
info.author = 'Dead Man Walker'


cfg = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + "/cfg/" + info.basename + ".cfg")
cfg.text("*****************************************************************")
cfg.text("*** Dropped Health Config")
cfg.text("*****************************************************************")
cfg.text(' ')
PICKUP_MODEL_PATH = cfg.cvar('pickup_model_path', "models/healthvial.mdl", 'Path of the model to be spawned')
PICKUP_SOUND = cfg.cvar('pickup_sound', "items/medshot4.wav", 'Path of the sound to be played when the model gets picked up')
PICKUP_SOUND_VOLUME = cfg.cvar('pickup_sound_volume', 0.7, 'Volume of the sound. 0-1')
PICKUP_HEALTH = cfg.cvar('pickup_health', 25,'Amount of health to gain')
PICKUP_HEALTH_LIMIT = cfg.cvar('pickup_health_limit', 100,'Limit of players health. Set to 0 for no limit')
PICKUP_ON_SUICIDE = cfg.cvar('pickup_on_suicide', 1, 'Dropp health if player committed suicide. 1=yes, 0=no')
PICKUP_ON_TEAMKILL = cfg.cvar('pickup_on_teamkill', 1, 'Dropp health if death was caused by a teamkill. 1=yes, 0=no')
PICKUP_OFFSET = cfg.cvar('pickup_linux_offset', 98, '"StartTouch" offset. May need to be changed on updates (See/ ask forums)')
cfg.write()
cfg.execute()

prop_list = []

def unload():
   spe.unHookFunction(FUNC_START_TOUCH, spe.HookType.Pre, preStartTouchEntity)

def round_start(event_var):
   global prop_list
   if prop_list:
      entity_list = es.createentityindexlist()
      for index in prop_list:
         if index in entity_list:
            es.remove(index)
   prop_list = []

def player_death(event_var):
   userid = int(event_var['userid'])
   attacker = int(event_var['attacker'])
   userid_team = event_var['es_userteam']
   attacker_team = event_var['es_attackerteam']
   if (int(PICKUP_ON_SUICIDE) and int(PICKUP_ON_TEAMKILL)) or (attacker not in (0, userid) and userid_team != attacker_team):
      createProp(userid)
   elif attacker in (0, userid) and int(PICKUP_ON_SUICIDE):
      createProp(userid)
   elif userid_team == attacker_team and int(PICKUP_ON_TEAMKILL) and attacker not in (0, userid):
      createProp(userid)

def createProp(userid):
   location = es.getplayerlocation(userid)
   es.precachemodel('models/' + str(PICKUP_MODEL_PATH).replace('models/', ''))
   index = es.createentity('prop_dynamic')
   es.entitysetvalue(index, 'model', 'models/' + str(PICKUP_MODEL_PATH).replace('models/', ''))
   es.entitysetvalue(index, 'origin', "%s %s %s" %(location[0], location[1], location[2]-35))
   es.entitysetvalue(index, 'solid', 2)
   es.InsertServerCommand('es_xspawnentity %s' %index)
   prop_list.append(index)

def preStartTouchEntity(args):
   ent_index = spe.getEntityIndex(args[1])
   if ent_index not in prop_list:
      return (spe.HookAction.Continue, 0)
   player_index = spe.getEntityIndex(args[0])
   for player in playerlib.getPlayerList('#alive'):
      if player.index != player_index:
         continue
      if player.health == int(PICKUP_HEALTH_LIMIT):
         continue
      if player.health + int(PICKUP_HEALTH) <= PICKUP_HEALTH_LIMIT:
         player.health += int(PICKUP_HEALTH)
      else:
         player.health = int(PICKUP_HEALTH_LIMIT)
      if str(PICKUP_SOUND):
         es.playsound(player.userid, str(PICKUP_SOUND).replace('sound/', ''), float(PICKUP_SOUND_VOLUME))
      spe.removeEntityByInstance(args[1])
      
      break
   return (spe.HookAction.Continue, 0)


def hookStartTouch(callback):
   index = es.createentity('info_target')
   pointer = spe.getEntityOfIndex(index)
   func = spe.findVirtualFunc(pointer, int(PICKUP_OFFSET))
   spe.hookFunction(func, 'pp)v', spe.Conventions.THISCALL, spe.HookType.Pre, callback)
   spe.removeEntityByInstance(pointer)
   return func

FUNC_START_TOUCH = hookStartTouch(preStartTouchEntity)

def player_say(ev):
   es.msg('NOBLOCK')
   for userid in es.getUseridList():
      playerlib.getPlayer(userid).noBlock = True